import os
import yaml

# Try to import CLoader from PyYAML for performance improvement; fallback to standard Loader if unavailable
try:
    from yaml import CLoader as Loader
except ImportError:
    from yaml import Loader

import numpy as np
from scipy.optimize import minimize
from colorama import Fore, Style

from .RO_functions import single_stage, economic_function
from .RO_functions import ro_solver_function as solver_function
from .RO_functions.logger import logger

from ..pretreatment import estimation_cost_pretreatment
from ..posttreatment import estimation_cost_posttreatment
from ..intake_system import estimation_power_and_cost_intake_system
from ...common import calculate_annual_depreciation_cost
from ...common import density_seawater_liquid
from ...common import calculate_pump_efficiency
from ...common import ResultList

def estimate_pump_cost(Qfeed_m3h, pressure_delta, tech_params, proj_params):
    """
    Estimate the cost of the high-pressure pump based on flow rate and pressure.

    Parameters:
    Qfeed_m3h (float): The feed flow rate in m³/h.
    pressure_delta (float): The required pressure difference (in bar) to be generated by the pump.
    tech_params (dict): Dictionary containing technical configuration and parameters.
    proj_params (dict): Dictionary containing project-specific configuration and parameters.

    Returns:
    float: Estimated pump cost in USD_current.
    """
    if Qfeed_m3h <= 450:
        return economic_function.estimation_HPpump_cost_single(Qfeed_m3h, pressure_delta, tech_params, proj_params)
    else:
        return economic_function.estimation_HPpump_cost_parallpumps(Qfeed_m3h, pressure_delta, tech_params, proj_params)


def reverse_osmosis_model_singlestage(tech_config_and_params, proj_config_and_params, nelem, N_trains, with_swip_and_posttreatment, with_preceding_nf, Mfeed, Xfeed, Xret_out, electricity_cost, with_erd):
    # input values
    Pfeed = 50
    N = 1
    #price_purewat = tech_config_and_params['specific_cost_water']
    price_purewat = proj_config_and_params['spec_price_commodity']['water']
    stage = solver_function.definition_solver_singlestage_discrete(tech_config_and_params,  nelem, Mfeed, Xfeed, Xret_out)
    res = minimize(stage.resolution_singlestage_Xretobj, Pfeed, method='Nelder-Mead')
    print("res:", res)

    '''calculations without overestimating the number of pressure vessels'''
    Qfeed_m3h = Mfeed * 3600 / density_seawater_liquid(tech_config_and_params['Feed_temperature'], Xfeed)
    
    ## permeate
    # 1st stage = total
    Vperm_stage = stage.Mpermeate_calc * 3600 / 1000 # [m3/h]
    Vperm_tot = Vperm_stage

    ## retentate 
    # 1st stage
    Mretent_stage = stage.Mc[stage.ndiscr-1, stage.nelem-1]  # [kg/s]
    Xretent_stage = stage.Xc[stage.ndiscr-1, stage.nelem-1]  # [ppm]
    Vretent_stage = Mretent_stage * 3600 / density_seawater_liquid(tech_config_and_params['Feed_temperature'], Xretent_stage)  # [m3/h]
    # total brine (both stages, if 2nd stage present)
    P_brine_out = stage.P[stage.nelem-1]
    Vbrine_out = Mretent_stage * 3600 / density_seawater_liquid(tech_config_and_params['Feed_temperature'], stage.Xretentate_out_plant)

    nelem_list = [nelem]
    Amembr_tot_calc_list = [stage.Amembr_tot_calc]
    tot_no_of_elements, elements_cost = economic_function.estimation_elements_cost(N, Amembr_tot_calc_list, tech_config_and_params, proj_config_and_params)
    NPV, vessels_cost = economic_function.estimation_pressurevessels_cost(N, nelem_list, Amembr_tot_calc_list,
                                                                          tech_config_and_params, proj_config_and_params)
    technical_train_size = np.empty(N, dtype=object)
    for iN in range(N):
        if NPV[iN] < 100:
            technical_train_size[iN] = "small_train"
        elif 100 <= NPV[iN] < 150:
            technical_train_size[iN] = "medium_train"
        else:
            technical_train_size[iN] = "large_train"
    print("number of pressure vessels (estimated by area, by stage), technical train size: ", NPV, stage.NPV, technical_train_size)
    piping_instrum_cost = economic_function.estimation_piping_trainsupporting_cost(N, technical_train_size, tech_config_and_params, proj_config_and_params)

    ## ERD
    # allowable portion of Qfeed_m3h into ERD for pressure increase: calculated using ERD efficiency formula (ref: Sanz Miguel A.; Stover R. 2007) and expected outlet pressure for Qfeed_erd_m3h, based on assumed booster pump pressure delta
    if with_erd:
        print("Considering ERD and its effects")
        Qfeed_erd_m3h = tech_config_and_params['erd_type']['PX']['efficiency'] * (P_brine_out * Vbrine_out) / (stage.Pfeed[0] - tech_config_and_params['booster_pump']['pressure_delta']) # [m3/h]
        erd_cost = economic_function.estimation_cost_erd_px(Vbrine_out, proj_config_and_params)
        
        ## HPP and BPP
        Qfeed_hpp_m3h = Qfeed_m3h-Qfeed_erd_m3h
        Qfeed_bpp_m3h = Qfeed_erd_m3h
        pump_cost_HPP = estimate_pump_cost(Qfeed_hpp_m3h, stage.Pfeed[0], tech_config_and_params, proj_config_and_params)
        pump_cost_BPP = estimate_pump_cost(Qfeed_bpp_m3h, tech_config_and_params['booster_pump']['pressure_delta'], tech_config_and_params, proj_config_and_params)
    else:
        print("Neglects ERD and its effects")
        erd_cost = 0
        Qfeed_hpp_m3h = Qfeed_m3h
        Qfeed_bpp_m3h = Qfeed_erd_m3h = 0
        pump_cost_HPP = estimate_pump_cost(Qfeed_hpp_m3h, stage.Pfeed[0], tech_config_and_params, proj_config_and_params)
        pump_cost_BPP = 0

    # intake + pretreatment system (SWIP) + posttreatment
    if with_swip_and_posttreatment:
        # brinetech_base_path is 4 folders up
        brinetech_base_path = os.path.abspath(os.path.join(os.path.realpath(__file__), "../../../.."))
        intake_tech_config_and_params_path = os.path.join(brinetech_base_path, "inputs", "intake_system", 'parameters.yml')
        pretreat_tech_config_and_params_path = os.path.join(brinetech_base_path, "inputs", "pretreatment", 'parameters.yml')
        posttreat_tech_config_and_params_path = os.path.join(brinetech_base_path, "inputs", "posttreatment", 'parameters.yml')
        
        # load the yaml files
        with open(intake_tech_config_and_params_path, "r") as file_params:
            intake_tech_config_and_params = yaml.load(file_params, Loader=Loader)
        with open(pretreat_tech_config_and_params_path, "r") as file_params:
            pretreat_tech_config_and_params = yaml.load(file_params, Loader=Loader)
        with open(posttreat_tech_config_and_params_path, "r") as file_params:
            posttreat_tech_config_and_params = yaml.load(file_params, Loader=Loader)
        ## intake
        power_intake_pump, capital_cost_intake_system = estimation_power_and_cost_intake_system(Qfeed_m3h, intake_tech_config_and_params, proj_config_and_params)
        ## pretreatment
        capital_cost_physical_and_chemical_pretreatment, annual_pretreatment_chem_cost = estimation_cost_pretreatment(Qfeed_m3h, pretreat_tech_config_and_params, proj_config_and_params)
        pretreat_spec_elec_consumption = pretreat_tech_config_and_params["spec_elec_consumption"]
        #SWIP_cost = economic_function.estimation_intake_pretreat_cost_updated(Qfeed_m3h, proj_config_and_params)
        #pretreat_spec_elec_consumption = tech_config_and_params["pretreat_spec_elec_consumption"]
        ## posttreatment
        capital_cost_posttreatment, annual_posttreatment_chem_cost = estimation_cost_posttreatment(Vperm_tot, posttreat_tech_config_and_params, proj_config_and_params)
        posttreat_spec_elec_consumption = posttreat_tech_config_and_params["posttreat_spec_elec_consumption"]
    else:
        ## intake
        capital_cost_intake_system = 0
        power_intake_pump = 0
        ## pretreatment
        capital_cost_physical_and_chemical_pretreatment = 0
        annual_pretreatment_chem_cost = 0
        pretreat_spec_elec_consumption = 0
        ## posttreatment
        capital_cost_posttreatment = 0
        annual_posttreatment_chem_cost = 0
        posttreat_spec_elec_consumption = 0
   
    # power
    HPP_efficiency = calculate_pump_efficiency((Qfeed_m3h-Qfeed_erd_m3h)*24)
    power_HPP = (stage.Pfeed[0] - 1) * (Qfeed_m3h-Qfeed_erd_m3h) / HPP_efficiency * 1e5 * 1e-3 / 3600  # kW
    BPP_efficiency = calculate_pump_efficiency((Qfeed_erd_m3h)*24)
    power_BPP = tech_config_and_params['booster_pump']['pressure_delta'] * Qfeed_erd_m3h / BPP_efficiency * 1e5 * 1e-3 / 3600  # kW

    ## electricity consumption (entire desalination plant)
    tot_spec_el_consumption = ((power_HPP+power_BPP+power_intake_pump) / Vperm_tot) + pretreat_spec_elec_consumption + posttreat_spec_elec_consumption  # [kWh/m3 of product water]

    # capital expenditures (USD)
    ROstructure_cost = elements_cost + vessels_cost + piping_instrum_cost
    equipment_cost = ROstructure_cost + pump_cost_HPP + pump_cost_BPP + erd_cost + \
                        capital_cost_intake_system + capital_cost_physical_and_chemical_pretreatment + capital_cost_posttreatment
    site_cost = tech_config_and_params['perc_site_equip'] * equipment_cost
    # direct
    total_direct_cost = equipment_cost + site_cost
    # indirect
    total_indirect_cost = tech_config_and_params['perc_TIndCC_TDCC'] * total_direct_cost
    # total
    total_fixed_cost = total_direct_cost + total_indirect_cost
    ## annualization of fixed cost
    if with_preceding_nf:
        depr_period = tech_config_and_params["depr_period"]["with_preceding_nf"]
    else:
        depr_period = tech_config_and_params["depr_period"]["standalone_plant"]
    interest_rate = proj_config_and_params["interest_rate"]
    annualized_fixed_cost = calculate_annual_depreciation_cost(interest_rate, depr_period, total_fixed_cost)
    
    Vperm_tot_annual = Vperm_tot * 24 * 365 * tech_config_and_params['plant_availability']  # [m3_perm/year]
    Vperm_tot_per_day_capacity = Vperm_tot * 24  # [capacity of m3_perm/day]
    Vretent_tot_annual = Vretent_stage * 24 * 365 * tech_config_and_params['plant_availability']  # [m3_perm/year]
    levelized_fixed_cost_per_m3_dist = annualized_fixed_cost / Vperm_tot_annual
    levelized_fixed_cost_per_m3_brine = annualized_fixed_cost / Vretent_tot_annual

    ## annualization of fixed expenditures, if already not annual (USD/y)
    # direct
    #annualized_ROstructure_cost = calculate_annual_depreciation_cost(interest_rate, depr_period, ROstructure_cost)
    annualized_elements_cost = calculate_annual_depreciation_cost(interest_rate, depr_period, elements_cost)
    annualized_vessels_cost = calculate_annual_depreciation_cost(interest_rate, depr_period, vessels_cost)
    annualized_piping_instrum_cost = calculate_annual_depreciation_cost(interest_rate, depr_period, piping_instrum_cost)
    annualized_intake_system_cost = calculate_annual_depreciation_cost(interest_rate, depr_period, capital_cost_intake_system)
    annualized_pretreament_cost = calculate_annual_depreciation_cost(interest_rate, depr_period, capital_cost_physical_and_chemical_pretreatment)
    annualized_posttreament_cost = calculate_annual_depreciation_cost(interest_rate, depr_period, capital_cost_posttreatment)
    #annual_SWIP_cost = calculate_annual_depreciation_cost(interest_rate, depr_period, SWIP_cost)
    annualized_HPP_cost = calculate_annual_depreciation_cost(interest_rate, depr_period, pump_cost_HPP)
    annualized_BPP_cost = calculate_annual_depreciation_cost(interest_rate, depr_period, pump_cost_BPP)
    annualized_erd_cost = calculate_annual_depreciation_cost(interest_rate, depr_period, erd_cost)
    annualized_site_cost = calculate_annual_depreciation_cost(interest_rate, depr_period, site_cost)
    # indirect
    annualized_indirect_cost = calculate_annual_depreciation_cost(interest_rate, depr_period, total_indirect_cost)

    #### variable operating costs (assumed to consist of labor, maintenance, energy, membrane replacement, chemicals)
    # labor
    annual_personnel_cost = economic_function.estimation_labour_cost_updated(Qfeed_m3h, tech_config_and_params)
    #volume_personnel_cost = annual_personnel_cost / (Vperm_tot * 24 * 365 * tech_config_and_params['plant_availability'])
    # maintenance
    annual_maintenance_cost = economic_function.estimation_maintenance_cost(equipment_cost, annual_personnel_cost, tech_config_and_params) # maintenance cost only on equipment cost, not other cost parts of fixed cost!
    #volume_maintenance_cost = annual_maintenance_cost / (Vperm_tot * 24 * 365 * tech_config_and_params['plant_availability'])
    # electricity
    annual_electric_cost = economic_function.estimation_electric_cost(tot_spec_el_consumption, stage.Mpermeate_calc, electricity_cost, tech_config_and_params)
    # membrane replacement
    annual_membr_replacement_cost = economic_function.estimation_membrane_replac_cost(N, NPV, nelem_list, with_preceding_nf, tech_config_and_params, proj_config_and_params)
    #volumetric_membr_replacement_cost = annual_membr_replacement_cost / (Vperm_tot * 24 * 365 * tech_config_and_params['plant_availability'])
    
    annual_chemical_cost = annual_pretreatment_chem_cost + annual_posttreatment_chem_cost
    #volumetric_chemical_cost = annual_chemical_cost / (Vperm_tot * 24 * 365 * tech_config_and_params['plant_availability'])
    
    # total variable operating
    annual_operating_cost = annual_personnel_cost + annual_maintenance_cost + annual_electric_cost + annual_membr_replacement_cost + annual_chemical_cost
    levelized_operating_cost_per_m3_dist = annual_operating_cost / Vperm_tot_annual
    levelized_operating_cost_per_m3_brine = annual_operating_cost / Vretent_tot_annual
    
    ## total (fixed + variable operating)
    annual_total_cost = annualized_fixed_cost + annual_operating_cost
    levelized_cost_per_m3_dist = levelized_fixed_cost_per_m3_dist + levelized_operating_cost_per_m3_dist
    levelized_cost_per_m3_brine = levelized_fixed_cost_per_m3_brine + levelized_operating_cost_per_m3_brine
    #annual_revenue_purewater = price_purewat / 1000 * stage.Mpermeate_calc * 3600 * 8760 * tech_config_and_params['plant_availability']
    #annual_Mdist = Vperm_tot * 24 * 365 * tech_config_and_params['plant_availability']
    annual_revenue_purewater = price_purewat * Vperm_tot_annual
    annual_Mdist = Vperm_tot_annual

    ro_inputs = ResultList(title="Ro simulation-single stage", xls_sheet="reverse_osmosis", results=[
        ('input and parameters', ('', '')),
        ('No. of trains', (N_trains, '-')),
        ('Mfeed per train', (Mfeed, 'kg/s')),
        ('Qfeed_m3h per train', (Qfeed_m3h, 'm3/h')),
        ('Xfeed', (Xfeed, 'ppm')),
        ('Xret_out', (Xret_out, 'ppm')),
        ('n elem', (nelem, '-')),
        ('A membrane single', (tech_config_and_params['membrane_area_sw'], 'm2')),
        ('Elec cost', (electricity_cost, 'USD/kWh'))])

    ro_results_stage = ResultList(title="results stage", xls_sheet="reverse_osmosis", xls_y0=5, results=[
        ('Pfeed', (stage.Pfeed[0], 'bar')),
        ('Recovery', (stage.R1_calc, '-')),
        ('M permeate', (stage.Mpermeate_calc, 'kg/s')),
        ('Flux permeate', (stage.Mpermeate_calc*3600/(stage.NPV*nelem*tech_config_and_params["membrane_area_sw"]), 'l/m2/h')),
        ('M retentate', (Mretent_stage, 'kg/s')),
        ('X perm', (stage.Xp_cum, 'ppm')),
        ('X retentate calc', (Xretent_stage, 'ppm')),
        ('Vperm', (Vperm_stage, 'm3/h')),
        ('Vret', (Vretent_stage, 'm3/h')),
        ('A membrane tot', (stage.Amembr_tot_calc, 'm2')),
        ('N elements', (tot_no_of_elements[0], '-')),
        ('N pressure vessel', (stage.NPV, '-')),
        ('', ('', '')),
        ('power and electricity consumption and feed flow rate and pressure delta', ('kW', 'kWh/m3_perm', 'm3/h', 'bar')),
        ('HPP', (power_HPP, power_HPP / Vperm_tot, Qfeed_m3h-Qfeed_erd_m3h,stage.Pfeed[0])),
        ('BPP', (power_BPP, power_BPP / Vperm_tot, Qfeed_erd_m3h, tech_config_and_params['booster_pump']['pressure_delta'])),
        ('Intake pump', (power_intake_pump, power_intake_pump / Vperm_tot, Qfeed_m3h, tech_config_and_params["intake_pump_pressure"])),
        ('Pretreatment', ('', pretreat_spec_elec_consumption)),
        ('Posttreatment', ('', posttreat_spec_elec_consumption)),
        ('Total', (power_HPP+power_BPP+power_intake_pump, tot_spec_el_consumption))
        ])
    
    ro_results_element = ResultList(title="results elements", xls_sheet="reverse_osmosis", xls_x0=22, xls_y0=0, results=[
        ('nelem', ('Relem', 'Mf_in', 'Mret_out', 'Mp_out', 'Mp_cum_out', 'Xf_in', 'Xret_out', 'Xp_out', 'Fw average', 'Fs average')),
        ('-', ('-', 'kg/s', 'kg/s', 'kg/s', 'kg/s', 'ppm', 'ppm', 'ppm', 'kg/(m2 s)', 'kg/(m2 s)', 'l/m2/h'))
        ] + [
            (str(i_elem+1), (
                stage.aver_recovery_elem[i_elem],
                stage.Mf[0, i_elem],
                stage.Mc[stage.ndiscr-1, i_elem],
                stage.Mp[stage.ndiscr-1, i_elem],
                stage.Mp_cum[stage.ndiscr-1, i_elem],
                stage.Xf[0, i_elem],
                stage.Xc[stage.ndiscr-1, i_elem],
                stage.Xp[stage.ndiscr-1, i_elem],
                np.average(stage.Fw[:, i_elem]),
                np.average(stage.Fs[:, i_elem])
         )) for i_elem in range(nelem)
        ])

    ro_results_economic = ResultList(title="economic results", xls_sheet="reverse_osmosis", xls_y0=10, results=[
        ('capex', ('$/y', '$', '$/m3_perm_capacity/day')),
        #('ROstructure', (annualized_ROstructure_cost, ROstructure_cost, ROstructure_cost/Vperm_tot_per_day_capacity)),
        ('ROstructure (elements_cost)', (annualized_elements_cost, elements_cost, elements_cost/Vperm_tot_per_day_capacity)),
        ('ROstructure (vessels_cost)', (annualized_vessels_cost, vessels_cost, vessels_cost/Vperm_tot_per_day_capacity)),
        ('ROstructure (piping_instrum_cost)', (annualized_piping_instrum_cost, piping_instrum_cost, piping_instrum_cost/Vperm_tot_per_day_capacity)),
        ('intake system', (annualized_intake_system_cost, capital_cost_intake_system, capital_cost_intake_system/Vperm_tot_per_day_capacity)),
        ('Pretreatment system', (annualized_pretreament_cost, capital_cost_physical_and_chemical_pretreatment, capital_cost_physical_and_chemical_pretreatment/Vperm_tot_per_day_capacity)),
        ('Posttreatment system', (annualized_posttreament_cost, capital_cost_posttreatment, capital_cost_posttreatment/Vperm_tot_per_day_capacity)),
        ('HP pump', (annualized_HPP_cost, pump_cost_HPP, pump_cost_HPP/Vperm_tot_per_day_capacity)),
        ('BP pump', (annualized_BPP_cost, pump_cost_BPP, pump_cost_BPP/Vperm_tot_per_day_capacity)),
        ('ERD', (annualized_erd_cost, erd_cost, erd_cost/Vperm_tot_per_day_capacity)),
        ('site cost', (annualized_site_cost, site_cost, site_cost/Vperm_tot_per_day_capacity)),
        ('indirect cost', (annualized_indirect_cost, total_indirect_cost, total_indirect_cost/Vperm_tot_per_day_capacity)),
        ('opex', ('$/y', '$/m3_perm')),
        ('personnel', (annual_personnel_cost, annual_personnel_cost/Vperm_tot_annual)),
        ('maintenance', (annual_maintenance_cost, annual_maintenance_cost/Vperm_tot_annual)),
        ('electric energy', (annual_electric_cost, annual_electric_cost/Vperm_tot_annual)),
        ('membrane replacement', (annual_membr_replacement_cost, annual_membr_replacement_cost/Vperm_tot_annual)),
        ('chemicals for pretreatment', (annual_pretreatment_chem_cost, annual_pretreatment_chem_cost/Vperm_tot_annual)),
        ('chemicals for posttreatment', (annual_posttreatment_chem_cost, annual_posttreatment_chem_cost/Vperm_tot_annual)),
        ])

    ro_results_total_cost = ResultList(title="total costs", xls_sheet="reverse_osmosis", xls_y0=16, results=[
        ('annual fixed cost', (annualized_fixed_cost, '$/y')),
        ('levelized fixed cost (per m3 dist)', (levelized_fixed_cost_per_m3_dist, '$/m3_dist')),
        ('levelized fixed cost (per m3 brine)', (levelized_fixed_cost_per_m3_brine, '$/m3_brine')),
        ('annual operating cost', (annual_operating_cost, '$/y')),
        ('levelized operating cost (per m3 dist)', (levelized_operating_cost_per_m3_dist, '$/m3_dist')),
        ('levelized operating cost (per m3 brine)', (levelized_operating_cost_per_m3_brine, '$/m3_brine')),
        ('total annual cost', (annual_total_cost, '$/y')),
        ('levelized cost (per m3 dist)', (levelized_cost_per_m3_dist, '$/m3_dist')),
        ('levelized cost (per m3 brine)', (levelized_cost_per_m3_brine, '$/m3_brine')),
        ('tot annual revenue water', (annual_revenue_purewater, '$/y')),
        ('Mdist annual', (annual_Mdist, 'm3/y'))
        ])

    return [ro_inputs, ro_results_stage, ro_results_element, ro_results_economic, ro_results_total_cost]


def reverse_osmosis_model_doublestage(tech_config_and_params, proj_config_and_params, nelem_1, nelem_2, N_trains, with_swip_and_posttreatment, with_preceding_nf, Mfeed, Xfeed, Xret_out, electricity_cost, with_erd):
    # input values
    Pfeed = 70
    N = 2
    #price_purewat = tech_config_and_params['specific_cost_water']
    price_purewat = proj_config_and_params['spec_price_commodity']['water']
    doublestage = solver_function.definition_solver_doublestage_discrete(tech_config_and_params, nelem_1, nelem_2, Mfeed, Xfeed, Xret_out)
    res = minimize(doublestage.resolution_doublestage_Xretobj, Pfeed, method='Nelder-Mead')
    print("res:", res)

    '''calculations without overestimating the number of pressure vessels'''
    Qfeed_m3h = Mfeed * 3600 / density_seawater_liquid(tech_config_and_params['Feed_temperature'], Xfeed)  # [m3/h]
    
    ## permeate
    # 1st stage
    Vperm_1st_stage = doublestage.Mpermeate_calc_1 * 3600 / 1000 # [m3/h]
    # 2nd stage
    Vperm_2nd_stage = doublestage.Mpermeate_calc_2 * 3600 / 1000  # [m3/h]
    # total permeate
    Vperm_tot = doublestage.Mpermeate_calc * 3600 / 1000  # [m3/h]
    Vperm_tot_list = [doublestage.Mpermeate_calc_1 * 3600 / 1000, doublestage.Mpermeate_calc_2 * 3600 / 1000]  # [m3/h]
    
    ## retentate 
    # 1st stage
    Mretent_1st_stage = doublestage.Mc[doublestage.ndiscr - 1, doublestage.nelem_1 - 1]  # [kg/s]
    Xretent_1st_stage = doublestage.Xc[doublestage.ndiscr - 1, doublestage.nelem_1 - 1]  # [ppm]
    Vretent_1st_stage = Mretent_1st_stage * 3600 / density_seawater_liquid(tech_config_and_params['Feed_temperature'], Xretent_1st_stage)  # [m3/h]
    # 2nd stage
    Mretent_2nd_stage = doublestage.Mc[doublestage.ndiscr - 1, doublestage.nelem - 1]  # [kg/s]
    Xretent_2nd_stage = doublestage.Xc[doublestage.ndiscr - 1, doublestage.nelem - 1]  # [ppm]
    Vretent_2nd_stage = Mretent_2nd_stage * 3600 / density_seawater_liquid(tech_config_and_params['Feed_temperature'], Xretent_2nd_stage)  # [m3/h]
    # total brine (both stages)
    P_brine_out = doublestage.P[doublestage.nelem - 1]
    Vbrine_out = doublestage.Mretentate_out_plant * 3600 / density_seawater_liquid(
        tech_config_and_params['Feed_temperature'], doublestage.Xretentate_out_plant)
    print("P_brine_out, Vbrine_out, Mbrineout", P_brine_out, Vbrine_out, doublestage.Mretentate_out_plant)
    

    nelem_list = [nelem_1, nelem_2]
    Amembr_tot_list = [doublestage.Amembr_tot_calc_1, doublestage.Amembr_tot_calc_2]
    #elements_cost = economic_function.estimation_elements_cost(N, nelem_list, tech_config_and_params, proj_config_and_params)
    tot_no_of_elements, elements_cost = economic_function.estimation_elements_cost(N, Amembr_tot_list, tech_config_and_params, proj_config_and_params)
    NPV, vessels_cost = economic_function.estimation_pressurevessels_cost(N, nelem_list, Amembr_tot_list,
                                                                          tech_config_and_params, proj_config_and_params)
    
    technical_train_size = np.empty(N, dtype=object)  # based on ref.: Desalination project cost estimating and management; 2019 (Voutchkov, Nikolay), pg. 80)
    for iN in range(N):
        if NPV[iN] < 100:
            technical_train_size[iN] = "small_train"
        elif 100 <= NPV[iN] < 150:
            technical_train_size[iN] = "medium_train"
        else:
            technical_train_size[iN] = "large_train"
    print("number of pressure vessels (estimated by area (only 2nd stage?), by stage), array of technical train size: ", NPV, doublestage.NPV_1, doublestage.NPV_2, technical_train_size)
    piping_instrum_cost = economic_function.estimation_piping_trainsupporting_cost(N, technical_train_size, tech_config_and_params, proj_config_and_params)

    ## ERD
    # allowable portion of Qfeed_m3h into ERD for pressure increase: calculated using ERD efficiency formula (ref: Sanz Miguel A.; Stover R. 2007) and expected outlet pressure for Qfeed_erd_m3h, based on assumed booster pump pressure delta
    if with_erd:
        print("Considering ERD and its effects")
        Qfeed_erd_m3h = tech_config_and_params['erd_type']['PX']['efficiency'] * (P_brine_out * Vbrine_out) / (doublestage.Pfeed[0] - tech_config_and_params['booster_pump']['pressure_delta']) # [m3/h]
        erd_cost = economic_function.estimation_cost_erd_px(Vbrine_out, proj_config_and_params)

        ## HPP and BPP
        Qfeed_hpp_m3h = Qfeed_m3h-Qfeed_erd_m3h
        Qfeed_bpp_m3h = Qfeed_erd_m3h
        pump_cost_HPP = estimate_pump_cost(Qfeed_hpp_m3h, doublestage.Pfeed[0], tech_config_and_params, proj_config_and_params)
        pump_cost_BPP = estimate_pump_cost(Qfeed_bpp_m3h, tech_config_and_params['booster_pump']['pressure_delta'], tech_config_and_params, proj_config_and_params)
    else:
        print("Neglects ERD and its effects")
        erd_cost = 0
        Qfeed_hpp_m3h = Qfeed_m3h
        Qfeed_bpp_m3h = Qfeed_erd_m3h = 0
        pump_cost_HPP = estimate_pump_cost(Qfeed_hpp_m3h, doublestage.Pfeed[0], tech_config_and_params, proj_config_and_params)
        pump_cost_BPP = 0


    # intake + pretreatment system (SWIP) + posttreatment
    if with_swip_and_posttreatment:
        # brinetech_base_path is 4 folders up
        brinetech_base_path = os.path.abspath(os.path.join(os.path.realpath(__file__), "../../../.."))
        intake_tech_config_and_params_path = os.path.join(brinetech_base_path, "inputs", "intake_system", 'parameters.yml')
        pretreat_tech_config_and_params_path = os.path.join(brinetech_base_path, "inputs", "pretreatment", 'parameters.yml')
        posttreat_tech_config_and_params_path = os.path.join(brinetech_base_path, "inputs", "posttreatment", 'parameters.yml')
        
        # load the yaml files
        with open(intake_tech_config_and_params_path, "r") as file_params:
            intake_tech_config_and_params = yaml.load(file_params, Loader=Loader)
        with open(pretreat_tech_config_and_params_path, "r") as file_params:
            pretreat_tech_config_and_params = yaml.load(file_params, Loader=Loader)
        with open(posttreat_tech_config_and_params_path, "r") as file_params:
            posttreat_tech_config_and_params = yaml.load(file_params, Loader=Loader)
        ## intake
        power_intake_pump, capital_cost_intake_system = estimation_power_and_cost_intake_system(Qfeed_m3h, intake_tech_config_and_params, proj_config_and_params)
        ## pretreatment
        capital_cost_physical_and_chemical_pretreatment, annual_pretreatment_chem_cost = estimation_cost_pretreatment(Qfeed_m3h, pretreat_tech_config_and_params, proj_config_and_params)
        pretreat_spec_elec_consumption = pretreat_tech_config_and_params["spec_elec_consumption"]
        #SWIP_cost = economic_function.estimation_intake_pretreat_cost_updated(Qfeed_m3h, proj_config_and_params)
        #pretreat_spec_elec_consumption = tech_config_and_params["pretreat_spec_elec_consumption"]
        ## posttreatment
        capital_cost_posttreatment, annual_posttreatment_chem_cost = estimation_cost_posttreatment(Vperm_tot, posttreat_tech_config_and_params, proj_config_and_params)
        posttreat_spec_elec_consumption = posttreat_tech_config_and_params["spec_elec_consumption"]
    else:
        ## intake
        capital_cost_intake_system = 0
        power_intake_pump = 0
        ## pretreatment
        capital_cost_physical_and_chemical_pretreatment = 0
        annual_pretreatment_chem_cost = 0
        pretreat_spec_elec_consumption = 0
        ## posttreatment
        capital_cost_posttreatment = 0
        annual_posttreatment_chem_cost = 0
        posttreat_spec_elec_consumption = 0

    # power
    HPP_efficiency = calculate_pump_efficiency((Qfeed_m3h-Qfeed_erd_m3h)*24)
    power_HPP = (doublestage.Pfeed[0] - 1) * (Qfeed_m3h-Qfeed_erd_m3h) / HPP_efficiency * 1e5 * 1e-3 / 3600  # kW
    BPP_efficiency = calculate_pump_efficiency((Qfeed_erd_m3h)*24)
    power_BPP = tech_config_and_params['booster_pump']['pressure_delta'] * Qfeed_erd_m3h / BPP_efficiency * 1e5 * 1e-3 / 3600  # kW
    
    ## electricity consumption (entire desalination plant)
    tot_spec_el_consumption = ((power_HPP+power_BPP+power_intake_pump) / Vperm_tot) + pretreat_spec_elec_consumption + posttreat_spec_elec_consumption # [kWh/m3 of product water]
    
    # capital expenditures (USD)
    ROstructure_cost = elements_cost + vessels_cost + piping_instrum_cost
    equipment_cost = ROstructure_cost + pump_cost_HPP + pump_cost_BPP + erd_cost + \
                        capital_cost_intake_system + capital_cost_physical_and_chemical_pretreatment + capital_cost_posttreatment
    site_cost = tech_config_and_params['perc_site_equip'] * equipment_cost
    # direct
    total_direct_cost = equipment_cost + site_cost
    # indirect
    total_indirect_cost = tech_config_and_params['perc_TIndCC_TDCC'] * total_direct_cost
    # total
    total_fixed_cost = total_direct_cost + total_indirect_cost
    ## annualization of fixed cost
    if with_preceding_nf:
        depr_period = tech_config_and_params["depr_period"]["with_preceding_nf"]
    else:
        depr_period = tech_config_and_params["depr_period"]["standalone_plant"]
    interest_rate = proj_config_and_params["interest_rate"]
    annualized_fixed_cost = calculate_annual_depreciation_cost(interest_rate, depr_period, total_fixed_cost)
    
    Vperm_tot_annual = Vperm_tot * 24 * 365 * tech_config_and_params['plant_availability']  # [m3_perm/year]
    Vperm_tot_per_day_capacity = Vperm_tot * 24  # [capacity of m3_perm/day]
    Vretent_tot_annual = Vretent_2nd_stage * 24 * 365 * tech_config_and_params['plant_availability']  # [m3_perm/year]
    levelized_fixed_cost_per_m3_dist = annualized_fixed_cost / Vperm_tot_annual  # [USD/m3 of perm]
    levelized_fixed_cost_per_m3_brine = annualized_fixed_cost / Vretent_tot_annual  # [USD/m3 of brine]

    ## annualization of fixed expenditures, if already not annual (USD/y)
    # direct
    annualized_elements_cost = calculate_annual_depreciation_cost(interest_rate, depr_period, elements_cost)
    annualized_vessels_cost = calculate_annual_depreciation_cost(interest_rate, depr_period, vessels_cost)
    annualized_piping_instrum_cost = calculate_annual_depreciation_cost(interest_rate, depr_period, piping_instrum_cost)
    #ROstructure_cost = elements_cost + vessels_cost + piping_instrum_cost
    annualized_intake_system_cost = calculate_annual_depreciation_cost(interest_rate, depr_period, capital_cost_intake_system)
    annualized_pretreament_cost = calculate_annual_depreciation_cost(interest_rate, depr_period, capital_cost_physical_and_chemical_pretreatment)
    annualized_posttreament_cost = calculate_annual_depreciation_cost(interest_rate, depr_period, capital_cost_posttreatment)
    annualized_HPP_cost = calculate_annual_depreciation_cost(interest_rate, depr_period, pump_cost_HPP)
    annualized_BPP_cost = calculate_annual_depreciation_cost(interest_rate, depr_period, pump_cost_BPP)
    annualized_erd_cost = calculate_annual_depreciation_cost(interest_rate, depr_period, erd_cost)
    annualized_site_cost = calculate_annual_depreciation_cost(interest_rate, depr_period, site_cost)
    # indirect
    annualized_indirect_cost = calculate_annual_depreciation_cost(interest_rate, depr_period, total_indirect_cost)

    #### variable operating costs (assumed to consist of labor, maintenance, energy, membrane replacement, chemicals)
    # labor
    annual_personnel_cost = economic_function.estimation_labour_cost_updated(Vperm_tot, tech_config_and_params)
    #volume_personnel_cost = annual_personnel_cost / (Vperm_tot * 24 * 365 * tech_config_and_params['plant_availability'])
    # maintenance
    annual_maintenance_cost = economic_function.estimation_maintenance_cost(equipment_cost, annual_personnel_cost, tech_config_and_params) # maintenance cost only on equipment cost, not other cost parts of fixed cost!
    #volume_maintenance_cost = annual_maintenance_cost / (Vperm_tot * 24 * 365 * tech_config_and_params['plant_availability'])
    # electricity
    annual_electric_cost = economic_function.estimation_electric_cost(tot_spec_el_consumption, doublestage.Mpermeate_calc, electricity_cost, tech_config_and_params)
    # membrane replacement
    annual_membr_replacement_cost = economic_function.estimation_membrane_replac_cost(N, NPV, nelem_list, with_preceding_nf, tech_config_and_params, proj_config_and_params)
    #volumetric_membr_replacement_cost = annual_membr_replacement_cost / (Vperm_tot * 24 * 365 * tech_config_and_params['plant_availability'])
    # chemicals
    annual_chemical_cost = annual_pretreatment_chem_cost + annual_posttreatment_chem_cost
    #volumetric_chemical_cost = annual_chemical_cost / (Vperm_tot * 24 * 365 * tech_config_and_params['plant_availability'])
    
    # total variable operating
    annual_operating_cost = annual_personnel_cost + annual_maintenance_cost + annual_electric_cost + annual_membr_replacement_cost + annual_chemical_cost
    levelized_operating_cost_per_m3_dist = annual_operating_cost / Vperm_tot_annual
    levelized_operating_cost_per_m3_brine = annual_operating_cost / Vretent_tot_annual
    
    ## total (fixed + variable operating)
    annual_total_cost = annualized_fixed_cost + annual_operating_cost
    levelized_cost_per_m3_dist = levelized_fixed_cost_per_m3_dist + levelized_operating_cost_per_m3_dist
    levelized_cost_per_m3_brine = levelized_fixed_cost_per_m3_brine + levelized_operating_cost_per_m3_brine
    annual_revenue_purewater = price_purewat * Vperm_tot_annual
    annual_Mdist = Vperm_tot_annual

    ro_inputs = ResultList(title="Ro simulation-double stage", xls_sheet="reverse_osmosis", results=[
        ('input and parameters', ('', '')),
        ('No. of trains', (N_trains, '-')),
        ('Mfeed per train', (Mfeed, 'kg/s')),
        ('Qfeed_m3h per train', (Qfeed_m3h, 'm3/h')),
        ('Xfeed', (Xfeed, 'ppm')),
        ('Xret_out', (Xret_out, 'ppm')),
        ('n elem 1', (nelem_1, '-')),
        ('n elem 2', (nelem_2, '-')),
        ('A membrane single', (tech_config_and_params['membrane_area_sw'], 'm2')),
        ('Elec cost', (electricity_cost, 'USD/kWh'))])
    
    #electricity_cost
    
    
    ro_results_stage = ResultList(title="results stage", xls_sheet="reverse_osmosis", xls_y0=5, results=[
        ('', ('1st stage', '2nd stage', 'global')),
        ('Pfeed', (doublestage.Pfeed[0], doublestage.P[nelem_1], doublestage.Pfeed[0], 'bar')),
        ('Recovery', (doublestage.R1_calc, doublestage.R2_calc, doublestage.Rtot_calc, '-')),
        ('M permeate', (doublestage.Mpermeate_calc_1, doublestage.Mpermeate_calc_2, doublestage.Mpermeate_calc, 'kg/s')),
        ('Flux permeate', (doublestage.Mpermeate_calc_1*3600/(doublestage.NPV_1*nelem_1*tech_config_and_params["membrane_area_sw"]), doublestage.Mpermeate_calc_2*3600/(doublestage.NPV_2*nelem_2*tech_config_and_params["membrane_area_sw"]), doublestage.Mpermeate_calc*3600/((doublestage.NPV_1*nelem_1 + doublestage.NPV_2*nelem_2)*tech_config_and_params["membrane_area_sw"]), 'l/m2/h')),
        ('M retentate', (Mretent_1st_stage, Mretent_2nd_stage, Mretent_2nd_stage , 'kg/s')),
        ('X perm', (doublestage.Xp_cum_1, doublestage.Xp_cum, doublestage.Xp_cum, 'ppm')),
        ('X retentate calc', (Xretent_1st_stage, Xretent_2nd_stage, Xretent_2nd_stage , 'ppm')),
        ('Vperm', (Vperm_1st_stage, Vperm_2nd_stage, Vperm_tot, 'm3/h')),
        ('Vret', (Vretent_1st_stage, Vretent_2nd_stage, Vbrine_out, 'm3/h')),
        ('A membrane tot', (doublestage.Amembr_tot_calc_1, doublestage.Amembr_tot_calc_2, doublestage.Amembr_tot_calc, 'm2')),
        ('N elements', (tot_no_of_elements[0], tot_no_of_elements[1], np.sum(tot_no_of_elements), '-')),
        ('N pressure vessel', (doublestage.NPV_1, doublestage.NPV_2, doublestage.NPV_1 + doublestage.NPV_2, '-')),
        ('', ('', '')),
        ('power and electricity consumption and feed flow rate and pressure delta', ('kW', 'kWh/m3_perm', 'm3/h', 'bar')),
        ('HPP', (power_HPP, power_HPP / Vperm_tot, Qfeed_m3h-Qfeed_erd_m3h,doublestage.Pfeed[0])),
        ('BPP', (power_BPP, power_BPP / Vperm_tot, Qfeed_erd_m3h, tech_config_and_params['booster_pump']['pressure_delta'])),
        ('Intake pump', (power_intake_pump, power_intake_pump / Vperm_tot, Qfeed_m3h, tech_config_and_params["intake_pump_pressure"])),
        ('Pretreatment', ('', pretreat_spec_elec_consumption)),
        ('Posttreatment', ('', posttreat_spec_elec_consumption)),
        ('Total', (power_HPP+power_BPP+power_intake_pump, tot_spec_el_consumption))
        ])

    ro_results_element = ResultList(title="results elements", xls_sheet="reverse_osmosis", xls_x0=22, xls_y0=0, results=[
        ('nelem', ('Relem', 'Mf_in', 'Mret_out', 'Mp_out', 'Mp_cum_out', 'Xf_in', 'Xret_out', 'Xp_out', 'Fw average', 'Fs average')),
        ('-', ('-', 'kg/s', 'kg/s', 'kg/s', 'kg/s', 'ppm', 'ppm', 'ppm', 'kg/(m2 s)', 'kg/(m2 s)', 'l/m2/h)'))
        ] + [
            (str(i_elem+1), (
                doublestage.Rel[i_elem],
                doublestage.Mf[0, i_elem],
                doublestage.Mc[doublestage.ndiscr-1, i_elem],
                doublestage.Mp[doublestage.ndiscr-1, i_elem],
                doublestage.Mp_cum[doublestage.ndiscr-1, i_elem],
                doublestage.Xf[0, i_elem],
                doublestage.Xc[doublestage.ndiscr-1, i_elem],
                doublestage.Xp[doublestage.ndiscr-1, i_elem],
                np.average(doublestage.Fw[:, i_elem]),
                np.average(doublestage.Fs[:, i_elem])
         )) for i_elem in range(doublestage.nelem)
        ])

    ro_results_economic = ResultList(title="economic results", xls_sheet="reverse_osmosis", xls_y0=11, results=[
        ('capex', ('$/y', '$', '$/m3_perm_capacity/day')),
        ('ROstructure (elements_cost)', (annualized_elements_cost, elements_cost, elements_cost/Vperm_tot_per_day_capacity)),
        ('ROstructure (vessels_cost)', (annualized_vessels_cost, vessels_cost, vessels_cost/Vperm_tot_per_day_capacity)),
        ('ROstructure (piping_instrum_cost)', (annualized_piping_instrum_cost, piping_instrum_cost, piping_instrum_cost/Vperm_tot_per_day_capacity)),
        ('intake system', (annualized_intake_system_cost, capital_cost_intake_system, capital_cost_intake_system/Vperm_tot_per_day_capacity)),
        ('Pretreatment system', (annualized_pretreament_cost, capital_cost_physical_and_chemical_pretreatment, capital_cost_physical_and_chemical_pretreatment/Vperm_tot_per_day_capacity)),
        ('Posttreatment system', (annualized_posttreament_cost, capital_cost_posttreatment, capital_cost_posttreatment/Vperm_tot_per_day_capacity)),
        ('HP pump', (annualized_HPP_cost, pump_cost_HPP, pump_cost_HPP/Vperm_tot_per_day_capacity)),
        ('BP pump', (annualized_BPP_cost, pump_cost_BPP, pump_cost_BPP/Vperm_tot_per_day_capacity)),
        ('ERD', (annualized_erd_cost, erd_cost, erd_cost/Vperm_tot_per_day_capacity)),
        ('site cost', (annualized_site_cost, site_cost, site_cost/Vperm_tot_per_day_capacity)),
        ('indirect cost', (annualized_indirect_cost, total_indirect_cost, total_indirect_cost/Vperm_tot_per_day_capacity)),
        ('opex', ('$/y', '$/m3_perm')),
        ('personnel', (annual_personnel_cost, annual_personnel_cost/Vperm_tot_annual)),
        ('maintenance', (annual_maintenance_cost, annual_maintenance_cost/Vperm_tot_annual)),
        ('electric energy', (annual_electric_cost, annual_electric_cost/Vperm_tot_annual)),
        ('membrane replacement', (annual_membr_replacement_cost, annual_membr_replacement_cost/Vperm_tot_annual)),
        ('chemicals for pretreatment', (annual_pretreatment_chem_cost, annual_pretreatment_chem_cost/Vperm_tot_annual)),
        ('chemicals for posttreatment', (annual_posttreatment_chem_cost, annual_posttreatment_chem_cost/Vperm_tot_annual)),
        ])

    ro_results_total_cost = ResultList(title="total costs", xls_sheet="reverse_osmosis", xls_y0=16, results=[
        ('annual fixed cost', (annualized_fixed_cost, '$/y')),
        ('levelized fixed cost (per m3 dist)', (levelized_fixed_cost_per_m3_dist, '$/m3_dist')),
        ('levelized fixed cost (per m3 brine)', (levelized_fixed_cost_per_m3_brine, '$/m3_brine')),
        ('annual operating cost', (annual_operating_cost, '$/y')),
        ('levelized operating cost (per m3 dist)', (levelized_operating_cost_per_m3_dist, '$/m3_dist')),
        ('levelized operating cost (per m3 brine)', (levelized_operating_cost_per_m3_brine, '$/m3_brine')),
        ('total annual cost', (annual_total_cost, '$/y')),
        ('levelized cost (per m3 dist)', (levelized_cost_per_m3_dist, '$/m3_dist')),
        ('levelized cost (per m3 brine)', (levelized_cost_per_m3_brine, '$/m3_brine')),
        ('tot annual revenue water', (annual_revenue_purewater, '$/y')),
        ('Mdist annual', (annual_Mdist, 'm3/y'))
        ])
    
    return [ro_inputs, ro_results_stage, ro_results_element, ro_results_economic, ro_results_total_cost]


def reverse_osmosis_model(tech_config_and_params, proj_config_and_params, nelem_1, nelem_2, N_trains, with_swip_and_posttreatment, with_preceding_nf, Mfeed, Xfeed, Xret_out, electricity_cost, with_erd):
    Rtot = single_stage.global_balance_Rtot(Xfeed, Xret_out, tech_config_and_params['salt_rejection_sw'])
    if Rtot <= 0.5:
        logger.info('total recovery <= 0.5, single stage used')
        ro_inputs, ro_results_stage, ro_results_element, ro_results_economic, ro_results_total_cost = reverse_osmosis_model_singlestage(tech_config_and_params, proj_config_and_params, nelem_1, N_trains, with_swip_and_posttreatment, with_preceding_nf,
                                          Mfeed, Xfeed, Xret_out, electricity_cost, with_erd)
        if ro_results_stage["Pfeed"][0] > 70:
            logger.info('Pfeed too high (higher than 70 bar), double stage used')
            ro_inputs, ro_results_stage, ro_results_element, ro_results_economic, ro_results_total_cost = reverse_osmosis_model_doublestage(tech_config_and_params, proj_config_and_params, nelem_1, nelem_2, N_trains, with_swip_and_posttreatment, with_preceding_nf,
                                          Mfeed, Xfeed, Xret_out, electricity_cost, with_erd)
    else:
        logger.info('total recovery > 0.5, double stage used')
        ro_inputs, ro_results_stage, ro_results_element, ro_results_economic, ro_results_total_cost = reverse_osmosis_model_doublestage(tech_config_and_params, proj_config_and_params, nelem_1, nelem_2, N_trains, with_swip_and_posttreatment, with_preceding_nf,
                                          Mfeed, Xfeed, Xret_out, electricity_cost, with_erd)
    return [ro_inputs, ro_results_stage, ro_results_element, ro_results_economic, ro_results_total_cost]

#driver('input_data.yml', 'parameters.yml', 8, 6, 17.3458, 26455.82, 70000, 0.103, 'nikhil_trial')  # double stage
#driver('input_data.yml', 'parameters.yml', 8, 6, 17.3458, 26455.82, 40000, 0.103, 'nikhil_trial')  # single stage
